// made by http://wiki.kldp.org/wiki.php/primewizard
// EmacsKeyConverter.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "EmacsKeyConverter.h"


HINSTANCE hMod = NULL;
HHOOK hHook=NULL;

LRESULT CALLBACK KeyboardProc(int nCode, WPARAM wParam, LPARAM lParam);

BOOL APIENTRY DllMain( HINSTANCE hinstDLL, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	hMod = hinstDLL;

	if (ul_reason_for_call == DLL_PROCESS_DETACH)		
		UninstallKeyConverter();

    return TRUE;
}

LRESULT __declspec(dllexport) InstallKeyConverter(void)
{
	hHook=NULL;

	try
	{
		hHook = SetWindowsHookEx(WH_KEYBOARD, KeyboardProc, hMod, 0);
	}
	catch(...)
	{
		if(hHook)
		{
			if(::UnhookWindowsHookEx(hHook))
				hHook = NULL;
		}
	}

	return 0;
}

LRESULT __declspec(dllexport) UninstallKeyConverter(void)
{
	if(hHook)
	{
		if(::UnhookWindowsHookEx(hHook))
			hHook = NULL;
	}

	return 0;
}
LRESULT CALLBACK KeyboardProc(INT nCode, WPARAM w, LPARAM l)
{	
	if (nCode != HC_ACTION)
		return ::CallNextHookEx(hHook, nCode, w, l);

	const BYTE vkCode = (BYTE)w;
	const BOOL bKeyUp = (l & 0x80000000) ? TRUE : FALSE;
	const HWND hWin = ::GetForegroundWindow();

	char szClassName[32];
	::GetClassName(hWin,szClassName,32);

	if(!strcmp(szClassName,"Emacs"))
	{

		if(vkCode == VK_HANGUL && !bKeyUp)
		{
			if( !(::GetAsyncKeyState(VK_CONTROL) & 0x8000) && !(::GetAsyncKeyState(VK_MENU) & 0x8000) )
			{
				
				if(::GetAsyncKeyState(VK_SHIFT) & 0x8000)
				{
					::keybd_event(VK_CONTROL,0,0,0);
					::keybd_event(VK_MENU,0,0,0);
					::keybd_event(VK_F11,0,0,0);
					::keybd_event(VK_F11,0,KEYEVENTF_KEYUP,0);
					::keybd_event(VK_CONTROL,0,KEYEVENTF_KEYUP,0);
					::keybd_event(VK_MENU,0,KEYEVENTF_KEYUP,0);			
				}
				else
				{
					::keybd_event(VK_CONTROL,0,0,0);
					::keybd_event(::VkKeyScan('\\'),0,0,0);
					::keybd_event(::VkKeyScan('\\'),0,KEYEVENTF_KEYUP,0);
					::keybd_event(VK_CONTROL,0,KEYEVENTF_KEYUP,0);
				}
			}
	
		}

		if(vkCode == VK_HANJA && !bKeyUp)
		{
			if( !(::GetAsyncKeyState(VK_SHIFT) & 0x8000) && !(::GetAsyncKeyState(VK_MENU) & 0x8000) )
			{
				
				if(::GetAsyncKeyState(VK_CONTROL) & 0x8000)
				{
					::keybd_event(VK_SHIFT,0,0,0);
					::keybd_event(VK_MENU,0,0,0);
					::keybd_event(VK_F12,0,0,0);
					::keybd_event(VK_F12,0,KEYEVENTF_KEYUP,0);
					::keybd_event(VK_SHIFT,0,KEYEVENTF_KEYUP,0);
					::keybd_event(VK_MENU,0,KEYEVENTF_KEYUP,0);
					
				}
				else
				{
					::keybd_event(VK_CONTROL,0,0,0);
					::keybd_event(VK_SHIFT,0,0,0);
					::keybd_event(VK_MENU,0,0,0);
					::keybd_event(VK_F9,0,0,0);
					::keybd_event(VK_F9,0,KEYEVENTF_KEYUP,0);
					::keybd_event(VK_CONTROL,0,KEYEVENTF_KEYUP,0);
					::keybd_event(VK_SHIFT,0,KEYEVENTF_KEYUP,0);
					::keybd_event(VK_MENU,0,KEYEVENTF_KEYUP,0);
				}
			}

		}
	}

	return ::CallNextHookEx(hHook, nCode, w, l);
}